module top
(
		output wire [14:0] memory_mem_a,                          //                         memory.mem_a
		output wire [2:0]  memory_mem_ba,                         //                               .mem_ba
		output wire        memory_mem_ck,                         //                               .mem_ck
		output wire        memory_mem_ck_n,                       //                               .mem_ck_n
		output wire        memory_mem_cke,                        //                               .mem_cke
		output wire        memory_mem_cs_n,                       //                               .mem_cs_n
		output wire        memory_mem_ras_n,                      //                               .mem_ras_n
		output wire        memory_mem_cas_n,                      //                               .mem_cas_n
		output wire        memory_mem_we_n,                       //                               .mem_we_n
		output wire        memory_mem_reset_n,                    //                               .mem_reset_n
		inout  wire [39:0] memory_mem_dq,                         //                               .mem_dq
		inout  wire [4:0]  memory_mem_dqs,                        //                               .mem_dqs
		inout  wire [4:0]  memory_mem_dqs_n,                      //                               .mem_dqs_n
		output wire        memory_mem_odt,                        //                               .mem_odt
		output wire [4:0]  memory_mem_dm,                         //                               .mem_dm
		input  wire        memory_oct_rzqin,                      //                               .oct_rzqin
		input  wire        clk_clk,                               //                            clk.clk
		input  wire        reset_reset_n,                         //                          reset.reset_n
		output wire        hps_emac1_TX_CLK, //                   hps_0_hps_io.hps_io_emac1_inst_TX_CLK
		output wire        hps_emac1_TXD0,   //                               .hps_io_emac1_inst_TXD0
		output wire        hps_emac1_TXD1,   //                               .hps_io_emac1_inst_TXD1
		output wire        hps_emac1_TXD2,   //                               .hps_io_emac1_inst_TXD2
		output wire        hps_emac1_TXD3,   //                               .hps_io_emac1_inst_TXD3
		input  wire        hps_emac1_RXD0,   //                               .hps_io_emac1_inst_RXD0
		inout  wire        hps_emac1_MDIO,   //                               .hps_io_emac1_inst_MDIO
		output wire        hps_emac1_MDC,    //                               .hps_io_emac1_inst_MDC
		input  wire        hps_emac1_RX_CTL, //                               .hps_io_emac1_inst_RX_CTL
		output wire        hps_emac1_TX_CTL, //                               .hps_io_emac1_inst_TX_CTL
		input  wire        hps_emac1_RX_CLK, //                               .hps_io_emac1_inst_RX_CLK
		input  wire        hps_emac1_RXD1,   //                               .hps_io_emac1_inst_RXD1
		input  wire        hps_emac1_RXD2,   //                               .hps_io_emac1_inst_RXD2
		input  wire        hps_emac1_RXD3,   //                               .hps_io_emac1_inst_RXD3
		inout  wire        hps_qspi_IO0,     //                               .hps_io_qspi_inst_IO0
		inout  wire        hps_qspi_IO1,     //                               .hps_io_qspi_inst_IO1
		inout  wire        hps_qspi_IO2,     //                               .hps_io_qspi_inst_IO2
		inout  wire        hps_qspi_IO3,     //                               .hps_io_qspi_inst_IO3
		output wire        hps_qspi_SS0,     //                               .hps_io_qspi_inst_SS0
		output wire        hps_qspi_CLK,     //                               .hps_io_qspi_inst_CLK
		inout  wire        hps_sdio_CMD,     //                               .hps_io_sdio_inst_CMD
		inout  wire        hps_sdio_D0,      //                               .hps_io_sdio_inst_D0
		inout  wire        hps_sdio_D1,      //                               .hps_io_sdio_inst_D1
		output wire        hps_sdio_CLK,     //                               .hps_io_sdio_inst_CLK
		inout  wire        hps_sdio_D2,      //                               .hps_io_sdio_inst_D2
		inout  wire        hps_sdio_D3,      //                               .hps_io_sdio_inst_D3
		inout  wire        hps_usb1_D0,      //                               .hps_io_usb1_inst_D0
		inout  wire        hps_usb1_D1,      //                               .hps_io_usb1_inst_D1
		inout  wire        hps_usb1_D2,      //                               .hps_io_usb1_inst_D2
		inout  wire        hps_usb1_D3,      //                               .hps_io_usb1_inst_D3
		inout  wire        hps_usb1_D4,      //                               .hps_io_usb1_inst_D4
		inout  wire        hps_usb1_D5,      //                               .hps_io_usb1_inst_D5
		inout  wire        hps_usb1_D6,      //                               .hps_io_usb1_inst_D6
		inout  wire        hps_usb1_D7,      //                               .hps_io_usb1_inst_D7
		input  wire        hps_usb1_CLK,     //                               .hps_io_usb1_inst_CLK
		output wire        hps_usb1_STP,     //                               .hps_io_usb1_inst_STP
		input  wire        hps_usb1_DIR,     //                               .hps_io_usb1_inst_DIR
		input  wire        hps_usb1_NXT,     //                               .hps_io_usb1_inst_NXT
		output wire        hps_spim0_CLK,    //                               .hps_io_spim0_inst_CLK
		output wire        hps_spim0_MOSI,   //                               .hps_io_spim0_inst_MOSI
		input  wire        hps_spim0_MISO,   //                               .hps_io_spim0_inst_MISO
		output wire        hps_spim0_SS0,    //                               .hps_io_spim0_inst_SS0
		input  wire        hps_uart0_RX,     //                               .hps_io_uart0_inst_RX
		output wire        hps_uart0_TX,     //                               .hps_io_uart0_inst_TX
		inout  wire        hps_i2c0_SDA,     //                               .hps_io_i2c0_inst_SDA
		inout  wire        hps_i2c0_SCL,     //                               .hps_io_i2c0_inst_SCL
		input  wire        hps_can0_RX,      //                               .hps_io_can0_inst_RX
		output wire        hps_can0_TX,      //                               .hps_io_can0_inst_TX
		output wire        hps_trace_CLK,    //                               .hps_io_trace_inst_CLK
		output wire        hps_trace_D0,     //                               .hps_io_trace_inst_D0
		output wire        hps_trace_D1,     //                               .hps_io_trace_inst_D1
		output wire        hps_trace_D2,     //                               .hps_io_trace_inst_D2
		output wire        hps_trace_D3,     //                               .hps_io_trace_inst_D3
		output wire        hps_trace_D4,     //                               .hps_io_trace_inst_D4
		output wire        hps_trace_D5,     //                               .hps_io_trace_inst_D5
		output wire        hps_trace_D6,     //                               .hps_io_trace_inst_D6
		output wire        hps_trace_D7,     //                               .hps_io_trace_inst_D7
		inout  wire        hps_gpio_GPIO09,  //                               .hps_io_gpio_inst_GPIO09
		inout  wire        hps_gpio_GPIO35,  //                               .hps_io_gpio_inst_GPIO35
		inout  wire        hps_gpio_GPIO41,  //                               .hps_io_gpio_inst_GPIO41
		inout  wire        hps_gpio_GPIO42,  //                               .hps_io_gpio_inst_GPIO42
		inout  wire        hps_gpio_GPIO43,  //                               .hps_io_gpio_inst_GPIO43
		inout  wire        hps_gpio_GPIO44,  //                               .hps_io_gpio_inst_GPIO44
		output wire [3:0]  fpga_led_pio,
		output wire        emac0_fpga_mdc,                      //                   emac0_md_clk.clk
		input  wire        phy_rgmii_rgmii_rx_clk,                //                      phy_rgmii.rgmii_rx_clk
		input  wire [3:0]  phy_rgmii_rgmii_rxd,                   //                               .rgmii_rxd
		input  wire        phy_rgmii_rgmii_rx_ctl,                //                               .rgmii_rx_ctl
		output wire        phy_rgmii_rgmii_tx_clk,                //                               .rgmii_tx_clk
		output wire [3:0]  phy_rgmii_rgmii_txd,                   //                               .rgmii_txd
		output wire        phy_rgmii_rgmii_tx_ctl,                //                               .rgmii_tx_ctl
		inout  wire        emac0_fpga_mdio,
		output wire        hsmc_reset_out
);

wire emac_mdio_gmii_mdo_o_e;
wire emac_mdio_gmii_mdo_o; 
wire rgmii_tx_clk_raw;
wire hps_0_h2f_cold_reset_reset_n;
wire pll_to_phy_reset;
wire [27:0] stm_hw_events;
wire [3:0]  led_pio_external_connection_in_port; 
wire [3:0]  led_pio_external_connection_out_port;
wire [2:0]  hps_reset_req;
wire        hps_cold_reset;
wire        hps_warm_reset;
wire        hps_debug_reset;
wire        hps_fpga_reset_n;

cv_soc_rgmii_5csxfc6 soc_0 (
.memory_mem_a                          	(memory_mem_a),                          
.memory_mem_ba                         	(memory_mem_ba),                         
.memory_mem_ck                         	(memory_mem_ck),                         
.memory_mem_ck_n                       	(memory_mem_ck_n),                       
.memory_mem_cke                        	(memory_mem_cke),                        
.memory_mem_cs_n                       	(memory_mem_cs_n),                       
.memory_mem_ras_n                      	(memory_mem_ras_n),                      
.memory_mem_cas_n                      	(memory_mem_cas_n),                      
.memory_mem_we_n                       	(memory_mem_we_n),                       
.memory_mem_reset_n                    	(memory_mem_reset_n),                    
.memory_mem_dq                         	(memory_mem_dq),                         
.memory_mem_dqs                        	(memory_mem_dqs),                        
.memory_mem_dqs_n                      	(memory_mem_dqs_n),                      
.memory_mem_odt                        	(memory_mem_odt),                        
.memory_mem_dm                         	(memory_mem_dm),                         
.memory_oct_rzqin                      	(memory_oct_rzqin),                      
.clk_clk                               	(clk_clk),                               
.reset_reset_n                         	(reset_reset_n),  
.hps_0_h2f_reset_reset_n                (hps_fpga_reset_n),
.hps_0_hps_io_hps_io_emac1_inst_TX_CLK 	(hps_emac1_TX_CLK), 
.hps_0_hps_io_hps_io_emac1_inst_TXD0   	(hps_emac1_TXD0),   
.hps_0_hps_io_hps_io_emac1_inst_TXD1   	(hps_emac1_TXD1),   
.hps_0_hps_io_hps_io_emac1_inst_TXD2   	(hps_emac1_TXD2),   
.hps_0_hps_io_hps_io_emac1_inst_TXD3   	(hps_emac1_TXD3),   
.hps_0_hps_io_hps_io_emac1_inst_RXD0   	(hps_emac1_RXD0),   
.hps_0_hps_io_hps_io_emac1_inst_MDIO   	(hps_emac1_MDIO),   
.hps_0_hps_io_hps_io_emac1_inst_MDC    	(hps_emac1_MDC),    
.hps_0_hps_io_hps_io_emac1_inst_RX_CTL 	(hps_emac1_RX_CTL), 
.hps_0_hps_io_hps_io_emac1_inst_TX_CTL 	(hps_emac1_TX_CTL), 
.hps_0_hps_io_hps_io_emac1_inst_RX_CLK 	(hps_emac1_RX_CLK), 
.hps_0_hps_io_hps_io_emac1_inst_RXD1   	(hps_emac1_RXD1),   
.hps_0_hps_io_hps_io_emac1_inst_RXD2   	(hps_emac1_RXD2),   
.hps_0_hps_io_hps_io_emac1_inst_RXD3   	(hps_emac1_RXD3),   
.hps_0_hps_io_hps_io_qspi_inst_IO0     	(hps_qspi_IO0),     
.hps_0_hps_io_hps_io_qspi_inst_IO1     	(hps_qspi_IO1),     
.hps_0_hps_io_hps_io_qspi_inst_IO2     	(hps_qspi_IO2),     
.hps_0_hps_io_hps_io_qspi_inst_IO3     	(hps_qspi_IO3),     
.hps_0_hps_io_hps_io_qspi_inst_SS0     	(hps_qspi_SS0),     
.hps_0_hps_io_hps_io_qspi_inst_CLK     	(hps_qspi_CLK),     
.hps_0_hps_io_hps_io_sdio_inst_CMD     	(hps_sdio_CMD),     
.hps_0_hps_io_hps_io_sdio_inst_D0      	(hps_sdio_D0),      
.hps_0_hps_io_hps_io_sdio_inst_D1      	(hps_sdio_D1),      
.hps_0_hps_io_hps_io_sdio_inst_CLK     	(hps_sdio_CLK),     
.hps_0_hps_io_hps_io_sdio_inst_D2      	(hps_sdio_D2),      
.hps_0_hps_io_hps_io_sdio_inst_D3      	(hps_sdio_D3),      
.hps_0_hps_io_hps_io_usb1_inst_D0      	(hps_usb1_D0),      
.hps_0_hps_io_hps_io_usb1_inst_D1      	(hps_usb1_D1),      
.hps_0_hps_io_hps_io_usb1_inst_D2      	(hps_usb1_D2),      
.hps_0_hps_io_hps_io_usb1_inst_D3      	(hps_usb1_D3),      
.hps_0_hps_io_hps_io_usb1_inst_D4      	(hps_usb1_D4),      
.hps_0_hps_io_hps_io_usb1_inst_D5      	(hps_usb1_D5),      
.hps_0_hps_io_hps_io_usb1_inst_D6      	(hps_usb1_D6),      
.hps_0_hps_io_hps_io_usb1_inst_D7      	(hps_usb1_D7),      
.hps_0_hps_io_hps_io_usb1_inst_CLK     	(hps_usb1_CLK),     
.hps_0_hps_io_hps_io_usb1_inst_STP     	(hps_usb1_STP),     
.hps_0_hps_io_hps_io_usb1_inst_DIR     	(hps_usb1_DIR),     
.hps_0_hps_io_hps_io_usb1_inst_NXT     	(hps_usb1_NXT),     
.hps_0_hps_io_hps_io_spim0_inst_CLK    	(hps_spim0_CLK),    
.hps_0_hps_io_hps_io_spim0_inst_MOSI   	(hps_spim0_MOSI),   
.hps_0_hps_io_hps_io_spim0_inst_MISO   	(hps_spim0_MISO),   
.hps_0_hps_io_hps_io_spim0_inst_SS0    	(hps_spim0_SS0),    
.hps_0_hps_io_hps_io_uart0_inst_RX     	(hps_uart0_RX),     
.hps_0_hps_io_hps_io_uart0_inst_TX     	(hps_uart0_TX),     
.hps_0_hps_io_hps_io_i2c0_inst_SDA     	(hps_i2c0_SDA),     
.hps_0_hps_io_hps_io_i2c0_inst_SCL     	(hps_i2c0_SCL),     
.hps_0_hps_io_hps_io_can0_inst_RX      	(hps_can0_RX),      
.hps_0_hps_io_hps_io_can0_inst_TX      	(hps_can0_TX),      
.hps_0_hps_io_hps_io_trace_inst_CLK    	(hps_trace_CLK),    
.hps_0_hps_io_hps_io_trace_inst_D0     	(hps_trace_D0),     
.hps_0_hps_io_hps_io_trace_inst_D1     	(hps_trace_D1),     
.hps_0_hps_io_hps_io_trace_inst_D2     	(hps_trace_D2),     
.hps_0_hps_io_hps_io_trace_inst_D3     	(hps_trace_D3),     
.hps_0_hps_io_hps_io_trace_inst_D4     	(hps_trace_D4),     
.hps_0_hps_io_hps_io_trace_inst_D5     	(hps_trace_D5),     
.hps_0_hps_io_hps_io_trace_inst_D6     	(hps_trace_D6),     
.hps_0_hps_io_hps_io_trace_inst_D7     	(hps_trace_D7),     
.hps_0_hps_io_hps_io_gpio_inst_GPIO09  	(hps_gpio_GPIO09),  
.hps_0_hps_io_hps_io_gpio_inst_GPIO35  	(hps_gpio_GPIO35),  
.hps_0_hps_io_hps_io_gpio_inst_GPIO41  	(hps_gpio_GPIO41),  
.hps_0_hps_io_hps_io_gpio_inst_GPIO42  	(hps_gpio_GPIO42),  
.hps_0_hps_io_hps_io_gpio_inst_GPIO43  	(hps_gpio_GPIO43),  
.hps_0_hps_io_hps_io_gpio_inst_GPIO44  	(hps_gpio_GPIO44),  
.hps_0_f2h_stm_hw_events_stm_hwevents  	(stm_hw_events),  
.led_pio_external_connection_in_port   	(led_pio_external_connection_in_port),   
.led_pio_external_connection_out_port  	(led_pio_external_connection_out_port),  
.hps_0_f2h_cold_reset_req_reset_n      	(~hps_cold_reset),      
.hps_0_f2h_debug_reset_req_reset_n     	(~hps_debug_reset),     
.hps_0_f2h_warm_reset_req_reset_n      	(~hps_warm_reset),      
.emac0_md_clk_clk                      	(emac0_fpga_mdc),                      
.phy_rgmii_rgmii_rx_clk                	(phy_rgmii_rgmii_rx_clk),                
.phy_rgmii_rgmii_rxd                   	(phy_rgmii_rgmii_rxd),                   
.phy_rgmii_rgmii_rx_ctl                	(phy_rgmii_rgmii_rx_ctl),                
.phy_rgmii_rgmii_tx_clk                	(rgmii_tx_clk_raw),                
.phy_rgmii_rgmii_txd                   	(phy_rgmii_rgmii_txd),                   
.phy_rgmii_rgmii_tx_ctl                	(phy_rgmii_rgmii_tx_ctl),                
.hps_emac_mdio_gmii_mdi_i              	(emac0_fpga_mdio),              
.hps_emac_mdio_gmii_mdo_o              	(emac_mdio_gmii_mdo_o),              
.hps_emac_mdio_gmii_mdo_o_e            	(emac_mdio_gmii_mdo_o_e),            
.hps_emac_ptp_ptp_aux_ts_trig_i        	(1'b0),        
.hps_emac_ptp_ptp_pps_o                	(),                
.pll_0_locked_export                 	   (pll_0_locked_export)                   
);

ddio_out ddio_out_1 (                 //to create GTX_CLK based on rgmii_tx_clk
 	.outclock (rgmii_tx_clk_raw),     			
 	.dataout (phy_rgmii_rgmii_tx_clk),   			
 	.datain_h (1'b1),       			
 	.datain_l (1'b0)       			    			          
 );

// Source/Probe megawizard instance
hps_reset hps_reset_inst (
  .source_clk (clk_clk),
  .source     (hps_reset_req)
);

altera_edge_detector pulse_cold_reset (
  .clk       (clk_clk),
  .rst_n     (hps_fpga_reset_n),
  .signal_in (hps_reset_req[0]),
  .pulse_out (hps_cold_reset)
);
  defparam pulse_cold_reset.PULSE_EXT = 6;
  defparam pulse_cold_reset.EDGE_TYPE = 1;
  defparam pulse_cold_reset.IGNORE_RST_WHILE_BUSY = 1;

altera_edge_detector pulse_warm_reset (
  .clk       (clk_clk),
  .rst_n     (hps_fpga_reset_n),
  .signal_in (hps_reset_req[1]),
  .pulse_out (hps_warm_reset)
);
  defparam pulse_warm_reset.PULSE_EXT = 2;
  defparam pulse_warm_reset.EDGE_TYPE = 1;
  defparam pulse_warm_reset.IGNORE_RST_WHILE_BUSY = 1;
  
altera_edge_detector pulse_debug_reset (
  .clk       (clk_clk),
  .rst_n     (hps_fpga_reset_n),
  .signal_in (hps_reset_req[2]),
  .pulse_out (hps_debug_reset)
);
  defparam pulse_debug_reset.PULSE_EXT = 32;
  defparam pulse_debug_reset.EDGE_TYPE = 1;
  defparam pulse_debug_reset.IGNORE_RST_WHILE_BUSY = 1; 
 
assign hsmc_reset_out    = pll_0_locked_export ; //& hps_0_h2f_cold_reset_reset_n;
assign fpga_led_pio      = led_pio_external_connection_in_port;
assign led_pio_external_connection_in_port = {~pll_0_locked_export, led_pio_external_connection_out_port[2:0]};
assign emac0_fpga_mdio   = emac_mdio_gmii_mdo_o_e ? emac_mdio_gmii_mdo_o : 1'bz;
assign stm_hw_events    = {{24{1'b0}}, led_pio_external_connection_in_port};

endmodule
